Package ghidra.trace.database.map

# Class AbstractDBTraceAddressSnapRangePropertyMapOcclusionIterable<T>

java.lang.Object
ghidra.trace.database.map.AbstractDBTraceAddressSnapRangePropertyMapOcclusionIterable<T>

All Implemented Interfaces:
  `Iterable<Map.Entry<TraceAddressSnapRange,T>>`

Direct Known Subclasses:
  `DBTraceAddressSnapRangePropertyMapOcclusionIntoFutureIterable`, `DBTraceAddressSnapRangePropertyMapOcclusionIntoPastIterable`

public abstract class AbstractDBTraceAddressSnapRangePropertyMapOcclusionIterable<T> extends Object implements Iterable<Map.Entry<TraceAddressSnapRange,T>>

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final DBTraceAddressSnapRangePropertyMapSpace<T,?>`
  `space`
  `protected final TraceAddressSnapRange`
  `within`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractDBTraceAddressSnapRangePropertyMapOcclusionIterable(DBTraceAddressSnapRangePropertyMapSpace<T,?> space, TraceAddressSnapRange within)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected abstract Lifespan`
  `getOcclusionRange(Lifespan range)`
  Get the vertical range where entries could exist that occlude the given vertical range
  `protected abstract Rectangle2DDirection`
  `getVerticalDirection()`
  `PeekableIterator<Map.Entry<TraceAddressSnapRange,T>>`
  `iterator()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Field Details

  - ### space

    protected final DBTraceAddressSnapRangePropertyMapSpace<T,?> space

  - ### within

    protected final TraceAddressSnapRange within

- ## Constructor Details

  - ### AbstractDBTraceAddressSnapRangePropertyMapOcclusionIterable

    public AbstractDBTraceAddressSnapRangePropertyMapOcclusionIterable(DBTraceAddressSnapRangePropertyMapSpace<T,?> space, TraceAddressSnapRange within)

- ## Method Details

  - ### getVerticalDirection

    protected abstract Rectangle2DDirection getVerticalDirection()

  - ### getOcclusionRange

    protected abstract Lifespan getOcclusionRange(Lifespan range)
    Get the vertical range where entries could exist that occlude the given vertical range
    Parameters:
      `range` - the given range
    Returns:
      the range possibly containing entries which occlude the given range

  - ### iterator

    public PeekableIterator<Map.Entry<TraceAddressSnapRange,T>> iterator()
    Specified by:
      `iterator` in interface `Iterable<T>`